﻿// a very simple moving average filter
// 非常にシンプルな移動平均フィルタ
class MovingAverageFilter {
	private var _taps:Number;
	private var _values:Array;

	function MovingAverageFilter(taps:Number) {
		_taps = taps;
		_values = new Array(_taps);
	}

	function processSample(sample:Number):Number {
		var acc:Number = 0;
		var i:Number = 0;

		// put the new value to the top of the array
        // 配列の先頭に新しい値を代入
		_values[0] = sample;

		// sum up all values in the array to do averaging
        // 全ての値を加算平均する
		for (i = 0; i < _taps; i++) {
			acc = acc + _values[i];
		}
		acc = acc / _taps;

		// shift values one by one
        // 1つずつ配列の中の値をシフトする
        //          0  1  2  3  4  ...
        // before: [A][B][C][D][E] ...
        // after : [A][A][B][C][D] ...
		for (i = _taps - 1; i > 0; i--) {
			_values[i] = _values[i - 1];
		}

		return acc;
	}
}