﻿//剛体の抽象クラス
class RigidBody extends MovieClip {
	
	//質量
	public var mass:Number = 1;
	
	//反発係数
	public var elasticity:Number = 0.3;
	
	//摩擦
	public var friction:Number = 0.0;
	
	//力
	public var force:Vector;
	
	//速度
	public var velocity:Vector;
	
	//シミュレータの参照
	public var simulator:Simulator;
	
	//位置
	private var _position:Vector;
	
	public function init(x:Number, y:Number, mass:Number, elasticity:Number, friction:Number) {
		force = new Vector(0,0);
		velocity = new Vector(0,0);
		position = new Vector(x,y);
		this.mass = mass;
		this.elasticity = elasticity;
		this.friction = friction;
	}
	
	public function set position(p:Vector) {
		_position = p;
		_x = p.x;
		_y = p.y;
	}
	
	public function get position():Vector {
		return _position;
	}
	
	//並進運動を行う
	public function update():Void {
		force.y += simulator.gravity;
		velocity.plusEquals(force);
		position.plusEquals(velocity);
		
		_x = position.x;
		_y = position.y;
		force.x = 0;
		force.y = 0;
	}
	
	//衝突応答
	public function resolve(mtd:Vector, vel:Vector, normal:Vector, depth:Number, order:Number):Void {
		position.plusEquals(mtd);
		_x = position.x;
		_y = position.y;
		velocity = vel;
	}
}